% In order to be able to run this example, you should download
% the dataset from the address
% http://olivier.chapelle.cc/ssl-book/benchmarks.html
% and download/install LIBSVM from
% http://www.csie.ntu.edu.tw/~cjlin/libsvm
% or
% http://www.csie.ntu.edu.tw/~cjlin/libsvm/matlab/

%USPS:
data = load('SSL,set=2,data.mat');
index = load('SSL,set=2,splits,labeled=100.mat');
index = load('SSL,set=2,splits,labeled=10.mat');

%data.X = full(data.X);

Xl = data.X(index.idxLabs(1,:),:);
Nl = size(Xl, 1);
Xu = data.X(index.idxUnls(1,:),:);
Nu = size(Xu, 1);
labl = data.y(index.idxLabs(1,:),:);
labu = data.y(index.idxUnls(1,:),:);

X = [Xl; Xu];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Computing the hierarchical cluster kernel
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%K = h_cluster_kernel(Xl, Xu, 'single');
K = h_cluster_kernel(Xl, Xu, 'complete', 7, 'euclidean');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Kl = K(1:Nl, 1:Nl);
Ku = K(Nl+1:Nl+Nu, 1:Nl);
Kl = [(1:size(Kl,1))', Kl];
Ku = [(1:size(Ku,1))', Ku];

model = svmtrain(labl, Kl, '-t 4 -c 1');

% Training accuracy
[pred_train, acc_train, dec_values_train] = svmpredict(labl, Kl, model);
% Test accuracy
[pred_test, acc_test, dec_values_test] = svmpredict(labu, Ku, model);
